﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MyCoreAssembly
{
    public class DataManager
    {
        public void ValidateEntityReflect(EntityObject entity)
        {
            // Nadjem wrapper preko atributa
            Type wt = (
                        from wrapperType in
                            (
                                from assembly in AppDomain.CurrentDomain.GetAssemblies()
                                from type in assembly.GetTypes()
                                where type.IsDefined(typeof(EntityWrapperAttribute), false)
                                select type
                            )
                        from attribute in wrapperType.GetCustomAttributes(false)
                        where ((EntityWrapperAttribute)attribute).EntityType.Equals(entity.GetType())
                        select wrapperType
                     ).FirstOrDefault();

            // Instanciram ga
            var instance = Activator.CreateInstance(wt);
            

            // Dinamicki zovem Validate
            wt.GetMethod("Validate").Invoke(instance, new object[] { entity });
        }

        public void ValidateEntityDynamicDynamic(EntityObject entity)
        {
            // bez atributa
            // Nadjem wrapper preko atributa
            Type wt = (from assembly in AppDomain.CurrentDomain.GetAssemblies()
                       from type in assembly.GetTypes().Where(t => t.BaseType!= null && t.BaseType.IsGenericType)
                       where (type.BaseType.GetGenericTypeDefinition() == typeof(EntityWrapper<>)) && (type.BaseType.GetGenericArguments()[0] == entity.GetType())
                       select type).FirstOrDefault();

            // Instanciram ga
            dynamic instance = Activator.CreateInstance(wt);
            instance.Validate((dynamic)entity);
        }

        public void ValidateEntityOldSchool(EntityObject entity)
        {
            entity.GetWrapper().Validate(entity);
        }
    

    }
}
